#!/usr/bin/env python
#
# Problem EPage 410 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, pi, sin, cos

from gaussQuad import gaussQuad 
from goldSearch import bracket, search

def integrand_fn(p): 
    """
    Returns a function we can use to evaluate our integrand
    """
    return lambda x: sin(x) * cos(p*x) 

def f(p):
    """
    A function for minimization
    """
    fn = integrand_fn(p)
    I = gaussQuad( fn, 0, pi, 6 )
    return I

xStart = 0.5
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "f(x)= ", fMin

if False: 
    xs = np.linspace( 0, 4, 200 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('p')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()

