#!/usr/bin/env python
#
# Problem EPage 62
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, prod, diag, transpose 

from LUdecomp import LUdecomp, LUsolve

A_orig = asarray( [ [ 1, 0, 0, 0, 0 ], [ 1, 1, 1, 1, 1 ], [ 1, 3, 3**2, 3**3, 3**4 ], [ 1, 5, 5**2, 5**3, 5**4 ], [ 1, 6, 6**2, 6**3, 6**4 ] ], dtype=float ) 
A = A_orig.copy() 
b_orig = asarray( [ -1, 1, 3, 2, -2 ], dtype=float )
b = b_orig.copy()

# Factor our system:
# 
LUdecomp(A)

LUsolve(A,b)
print "Solution= ", map( lambda _: round(_,4), b )
assert np.linalg.norm( dot(A_orig,b) - b_orig ) < 1.e-6

# check our solution: 
best_fit_y = lambda x: -1 + 2.6833 * x -0.875 * x**2 + 0.2167 * x**3 -0.025 * x**4 
print map( best_fit_y, [ 0, 1, 3, 5, 6 ] ) 
