#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity, zeros, diag

from gaussSeidel import * 

def iterEqs(x,omega=1): 
    n = len(x)
    gs_update = ( b - ( dot(A,x) - diag(A) * x ) ) / diag(A) 
    return omega * gs_update + (1-omega) * x  

print "With A as given originally:"
A = asarray( [ [ -2, 5, 9 ], [ 7, 1, 1 ], [ -3, 7, -1 ] ], dtype=float ) 
b = asarray( [ 1, 6, -26 ], dtype=float ) 
print "A= "
print A 

# Perform Gauss-Seidel iterations: 
tol = 1.e-6
omega = 1.0
x = b / diag(A) 
solution_found = False 
for i in range(100): 
    xOld = x.copy()
    x = iterEqs(x,omega)
    dx = sqrt(dot(x-xOld,x-xOld))
    if dx < tol: 
        solution_found = True 
        break 
if solution_found: 
    print "x= ", x 
else: 
    print "No solution found" 
    print "norm(x)= ", np.linalg.norm(x)

print "\nWith A ordered so that it is diagonally dominate:"
perm = [1,2,0]
A = A[perm,:] 
b = b[perm]
print "A= "
print A 

# Perform Gauss-Seidel iterations on this new A: 
tol = 1.e-6
omega = 1.0
x = b / diag(A) 
solution_found = False 
for i in range(100): 
    xOld = x.copy()
    x = iterEqs(x,omega)
    dx = sqrt(dot(x-xOld,x-xOld))
    if dx < tol: 
        solution_found = True 
        break 
if solution_found: 
    print "x= ", x 
else: 
    print "No solution found" 
    print "norm(x)= ", np.linalg.norm(x)

# Check our solution: 
print np.linalg.norm(dot(A,x)-b)
