#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity, zeros, diag

from gaussSeidel import * 

def iterEqs(x,omega=1): 
    n = len(x)
    gs_update = ( b - ( dot(A,x) - diag(A) * x ) ) / diag(A) 
    return omega * gs_update + (1-omega) * x  

A = asarray( [ [ 12, -2, 3, 1 ], [ -2, 15, 6, -3 ], [ 1, 6, 20, -4 ], [ 0, -3, 2, 9 ] ], dtype=float ) 
b = asarray( [ 0, 0, 20, 0 ], dtype=float ) 

# Perform Gauss-Seidel iterations: 
tol = 1.e-6
omega = 1.0
x = b / diag(A) 
solution_found = False 
for i in range(100): 
    xOld = x.copy()
    x = iterEqs(x,omega)
    dx = sqrt(dot(x-xOld,x-xOld))
    if dx < tol: 
        solution_found = True 
        break 
if solution_found: 
    print "x= ", x 
else: 
    print "No solution found" 
    print "norm(x)= ", np.linalg.norm(x)

# Check our solution: 
print np.linalg.norm(dot(A,x)-b)
