#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity, zeros, diag, inf

from gaussSeidel import * 

def iterEqs(x,omega=1): 
    """
    Note: omega=1 give the pure Gauss-Seidel iteration method.
    """
    n = len(x)
    gs_update = ( b - ( dot(A,x) - diag(A) * x ) ) / diag(A) 
    return omega * gs_update + (1-omega) * x  

A = asarray( [ [ -5, 3, 0, 0, 0 ], [ 3, -6, 3, 0, 0 ], [ 0, 3, -6, 3, 0 ], [ 0, 0, 3, -6, 3 ], [ 0, 0, 0, 3, -5 ] ], dtype=float ) 
b = asarray( [ -80, 0, 0, 60, 0 ], dtype=float ) 
print "A= ", A 
print "b= ", b 

# Part (a): the direct Guass-Seidel method without any relaxation:
# 
n = len(b)
x_i = zeros( (n,), dtype=float )
err = inf
numIter = 1
while( (numIter < 1000) & (err > 1.e-6) ):
    x_ip1 = iterEqs(x_i)
    err = sqrt( sum( ( x_ip1 - x_i )**2 ) )
    numIter += 1 
    x_i = x_ip1 
x = x_i
print "x= ", x 
print "numIter= ", numIter
print np.linalg.norm(dot(A,x)-b) # Check our solution: 

# Part (b): using the routine guassSeidel:
# 
x = zeros( (n,), dtype=float )
x, numIter, omega = gaussSeidel(iterEqs, x, tol=1.e-3)
print "x= ", x 
print "numIter= ", numIter
print "omega= ", omega
print np.linalg.norm(dot(A,x)-b) # Check our solution: 
