#!/usr/bin/env python
#
# Problem EPage 131
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, argsort
import cubicSpline 

# Our data:
# 
xData = asarray( [ 0.2, 0.4, 0.6, 0.8, 1.0 ] )
yData = asarray( [ 1.150, 0.855, 0.377, -0.266, -1.049 ] )

# Reorder the y values: 
asy = argsort( yData ) 
xData = xData[asy]
yData = yData[asy] 

# Cubic spline interpolation:
# 
k = cubicSpline.curvatures(yData,xData)
interp_spline = cubicSpline.evalSpline(yData,xData,k,0.0)
print "approximate zero (inverse interpolation)= %10.6f" % (interp_spline)

    
