#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi
from neville import neville
import cubicSpline 

# Our data:
# 
xData = asarray( [ 0, 1.525, 3.050, 4.575, 6.10, 7.625, 9.150 ] )
yData = asarray( [ 1, 0.8617, 0.7385, 0.6292, 0.5328, 0.4481, 0.3741 ] ) 

x_interp = 10.5

# Neville's interpolation:
# 
y_interp_neville = neville(xData,yData,x_interp)
    
# Cubic spline interpolation:
# 
k = cubicSpline.curvatures(xData,yData)
y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 
    
print "h= %10.6f; neville= %10.6f, spline= %10.6f" % (x_interp,y_interp_neville,y_interp_spline)






