#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, zeros, cos, sin, pi, linalg

# Our data:
# 
xData = asarray( [ -0.5, -0.19, 0.02, 0.20, 0.35, 0.50 ] )
yData = asarray( [ -3.558, -2.874, -1.995, -1.040, -0.068, 0.677 ] )

# Fill the elements in each element of the 2 x 2 system that 
# 
sinData = sin( xData * pi / 2 )
cosData = cos( xData * pi / 2 ) 

A = zeros( (2,2) )
b = zeros( (2,1) ) 

A[0,0] = sum( sinData**2 ) 
A[0,1] = sum( sinData * cosData ) 
A[1,0] = A[0,1]
A[1,1] = sum( cosData**2 ) 
b[0] = sum( yData * sinData ) 
b[1] = sum( yData * cosData ) 

x = linalg.solve( A, b ) 
print "a= %10.6f; b= %10.6f" % (x[0],x[1])


