#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, hstack, ones, sqrt 
from polyFit import polyFit, stdDev

# Our data:
# 
xData_0 = asarray( [ 34.5, 69.0, 103.5, 138.0 ] ) * 1.e6 # units of Pa
yData_0 = asarray( [ [ 0.46, 0.95, 1.48, 1.93 ], [ 0.34, 1.02, 1.51, 2.09 ], [ 0.73, 1.10, 1.62, 2.12 ] ] ) * 1.e-3 # unitless

# Build the larger dataset:
# 
for _ in range(3) : 
    if _ == 0 : 
        xData = xData_0
        yData = yData_0[_,:]
    else : 
        xData = hstack( (xData,xData_0) )
        yData = hstack( (yData,yData_0[_,:]) )

# Create a weight vector: 
#
W = ones( (len(xData),1) )
W[ -len(xData_0): ] = 1./2 
W = W.flatten()

# Transform our X and Y so that we can use polyFit: 
# 
Y = W * yData 
X = W * xData 

coeff = polyFit( X, Y, 1 )
print "coeff= ", coeff
