#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import cos, sin, cosh, sinh, linspace, nan, pi, sqrt 
from newtonRaphson import *

def f(x,s_over_L): return sinh(x) / x - s_over_L
def df(x,s_over_L): return cosh(x) / x - sinh(x) / x**2 

if __name__ == "__main__":
    s = 1100 
    L = 1000 
    gamma = 77 * 1.e3
    s_over_L = float(s)/L

    if True: 
        xs = linspace( -0.5, +2, 500 ) 
        fs = [ f(_,s_over_L) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    beta = newtonRaphson( lambda _: f(_,s_over_L), lambda _: df(_,s_over_L), 0.5, 1.0 )
    print "beta= ", beta
    print "cosh(beta)= ", cosh(beta)
