#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, nan, sqrt 
from newtonRaphson import *

def f(x,LHS,C1,H): return C1 / x**2 + x + H - LHS 
def df(x,LHS,C1,H): return -2 * C1 / x**3 + 1 

if __name__ == "__main__":

    Q = 1.2 
    g = 9.81
    b = 1.8
    h0 = 0.6 
    H = 0.075

    # Compute the left-hand-side:
    # 
    LHS = Q**2 / ( 2 * g * b**2 * h0**2 ) + h0 
    C1 = Q**2 / ( 2 * g * b**2 ) 
    print "LHS, C1= ", LHS, C1

    if True: 
        xs = linspace( 0.07, +1.0, 100 )
        fs = [ f(_,LHS,C1,H) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    h_left = newtonRaphson( lambda _: f(_,LHS,C1,H), lambda _: df(_,LHS,C1,H), 0.2, 0.4 )
    print "h_left= ", h_left
    h_right = newtonRaphson( lambda _: f(_,LHS,C1,H), lambda _: df(_,LHS,C1,H), 0.4, 0.6 )
    print "h_right= ", h_right
