#!/usr/bin/env python
#
# Problem EPage 176
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, nan, sqrt, log
from newtonRaphson import *

def f(t,u,M0,m_dot,g,v_target): return u * log( M0 / ( M0 - m_dot * t ) ) - g * t - v_target 
def df(t,u,M0,m_dot,g,v_target): return ( u * m_dot ) / ( M0 - m_dot * t ) - g 

if __name__ == "__main__":

    u = 2510
    M0 = 2.8 * 1.e6 
    m_dot = 13.3 * 1.e6
    g = 9.81
    v_target = 335 

    if True: 
        t_max = M0  / m_dot 
        xs = linspace( 0.0, t_max, 100 )
        fs = [ f(_,u,M0,m_dot,g,v_target) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    t = newtonRaphson( lambda _: f(_,u,M0,m_dot,g,v_target), lambda _: df(_,u,M0,m_dot,g,v_target), 0.0, 0.05 )
    print "t= ", t
