#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import cos, sin, cosh, sinh, linspace

def f(x): return cosh(x) * cos(x) - 1
def df(x): return sinh(x) * cos(x) - cosh(x) * sin(x) 

if __name__ == "__main__":
    xs = linspace( 3.5, 8, 500 ) 
    fs = [ f(_) for _ in xs ]

    import pylab; 
    pylab.hold('on')

    pylab.plot( xs, fs ); 

    # Plot the line through (x0,f(x0)) with slope fp(x0):
    # 
    x0 = 4
    m = df(x0)
    ys = m * ( xs - x0 ) + f(x0)
    pylab.plot( xs, ys, color='red' )

    pylab.xlabel('x'); pylab.ylabel('f(x)');
    pylab.axhline(y=0,color='k')
    pylab.grid('on'); 
    pylab.show()
 

