#!/usr/bin/env python
#
# Problem EPage 239
# Table of Gauss-Legendre points on EPage 230
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import pi, sqrt, exp 
from gaussQuad import *

def f(t): return ( 2 / sqrt(pi) ) * exp( -t**2 ) 

def compute_error_function( x, tol=1.e-6, max_num_nodes=500 ):
    """
    """
    a, b = 0, x # limits of the integration 
    I_old = gaussQuad( f, a, b, 2 )
    for m in range(2+1,max_num_nodes+1):
        I_new = gaussQuad( f, a, b, m )
        if abs( I_new - I_old ) < tol * max(abs(I_new),1.0) : 
            return I_new, m  
        I_old = I_new
    print "Gauss-Legendre did not converge to desired tolerance using fewer than %5d nodes" % max_num_nodes

if __name__ == "__main__":
    for x in [ 0.1, 0.25, 0.5, 1.0, 2.0, 3.0, 5.0, 10.0 ]: 
        print x, compute_error_function( x )

