#!/usr/bin/env python
#
# Problem EPage 239
# Gauss-Chebyshev Quadrature on EPage 231
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import sqrt, pi, cos, asarray, arange

def f(x): return 1. / sqrt( 1 + x**2 ) # our f(x) after the suggested transformation 

N = 5 # the number of nodes minus one 
ns = arange( 0, N+1 )
xs = cos( ( 2*ns + 1 ) * pi / ( 2 * N + 2 ) )
fs = asarray( [ f(xs[_]) for _ in range(len(xs)) ] )
As = pi/(N+1)

I_truth = 2.62206
I = sum( As * fs )
print "Gauss-Chebyshev (%d nodes); I_approx= %10.6f; error= %10.6f" % (N+1,I,I_truth-I)



 
