#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, cos, asarray, zeros, interp
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

g = 9.80665
L = 1.
Y = 0.25
omega = 2.5

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -(g/L) * sin(y[0]) + ( omega**2 / L ) * Y * cos(y[0]) * sin( omega * x )
    return F

x0 = 0.0 # start of the integration 
xStop = 10.0 # end of the integration 
y0 = asarray( [ 0., 0. ], dtype=float ) 
h = 0.01
freq = 20

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('y(t)');
    pylab.grid('on')
    pylab.show() 

