#!/usr/bin/env python
#
# Problem EPage 278
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sqrt, sin, cos, asarray, zeros, argsort, interp, pi 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

g = 9.80665
k = 40 
L = 0.5
m = 0.25

def F(t,y): 
    theta, theta_dot, r, r_dot = y # vector y is = [ theta(t), theta'(t), r(t), r'(t) ]
    F = zeros( (4,), dtype=float ) 
    F[0] = theta_dot
    F[1] = ( - 2 * r_dot * theta_dot - g * sin(theta) ) / r 
    F[2] = r_dot
    F[3] = r * theta_dot**2 + g * cos(theta) - (k/m) * ( r - L ) 
    return F

t0 = 0.0 # start of the integration 
tStop = 0.6 # end of the integration 
y0 = asarray( [ 60 * ( pi / 180 ), 0., L, 0. ], dtype=float ) 
h = 0.01
freq = 0

T,Y = integrate(F,t0,y0,tStop,h) 
#printSoln(T,Y,freq)

# Find R when theta=0 is reached for the first time:
# 
t_inds = T > 0.4
thetas = Y[t_inds,0]
rs = Y[t_inds,2]
inds = argsort( thetas )
theta_sorted = thetas[inds]
r_sorted = rs[inds]
r_at_theta0 = interp( 0, theta_sorted, r_sorted ) 
print "R when theta=0 is= %10.6f" % r_at_theta0

if False:
    pylab.plot( T, Y[:,0] )
    pylab.xlabel('t (time)'); pylab.ylabel('theta(t)')
    pylab.grid('on')
    pylab.show() 
