#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sqrt, sin, cos, asarray, zeros, interp, pi 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

k = 3000
m = 6
mu = 0.5
g = 9.80665

def F(t,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -(k/m) * y[0] - mu * g * ( y[1] / abs(y[1]) ) 
    return F

t0 = 0.0 # start of the integration 
tStop = 0.5 # end of the integration 
y_initial = 0.1 
y0 = asarray( [ y_initial, 1.e-9 ], dtype=float ) 
h = 0.01
freq = 0

T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

next_positive_peak_value = y_initial - 4 * mu * m * g / k
print "y_0 - 4 mu m g / k= %10.6f" % next_positive_peak_value

if True:
    pylab.plot( T, Y[:,0] )
    pylab.axhline(y=next_positive_peak_value,color='black')
    pylab.xlabel('t (time)'); pylab.ylabel('y(t)')
    pylab.grid('on')
    pylab.show() 
