#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

def F(t,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -(1./t) * y[1] - y[0] 
    return F 

t0 = 1.e-12 # start of the integration 
tStop = 5.0 # end of the integration 
h = 0.01
freq = 0

y0 = asarray( [ 1, 0. ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if False:
    pylab.plot( T, Y[:,0] )
    pylab.xlabel('t (time)'); pylab.ylabel('y(t)')
    pylab.grid('on')
    pylab.show() 
 
