#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, asarray, zeros, interp
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

k = 75
m = 2.5

def P(t):
    if t < 2:
        return 10.*t
    else: 
        return 20.

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = P(x)/m - (k/m) * y[0] 
    return F

x0 = 0.0 # start of the integration 
xStop = 6.0 # end of the integration 
y0 = asarray( [ 0., 0. ], dtype=float ) 
h = 0.01
freq = 20

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if False: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('y(t)');
    pylab.axhline(y=0,color='green')
    pylab.grid('on')
    pylab.show() 

