#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sqrt, exp, sin 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -2 * y[1] - 3 * y[0]
    return F 

x0 = 0.0 # start of the integration 
xStop = 5 # end of the integration 
h = 0.05
freq = 0

y0 = asarray( [ 0., sqrt(2) ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

Y_truth = exp( -X ) * sin( sqrt(2) * X ) 

if True: 
    pylab.plot( X, Y[:,0], color='black', label='approx.' )
    pylab.hold('on')
    pylab.plot( X, Y_truth, color='green', label='truth' )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.legend()
    pylab.show() 
