#!/usr/bin/env python
#
# Problem EPage 280
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

a = 5.0 
b = 0.9

def F(t,y): 
    u, v, w = y
    F = zeros( (len(y),), dtype=float ) 
    F[0] = - a * u + a * v 
    F[1] = c * u - v - u * w 
    F[2] = - b * w + u * v 
    return F 

t0 = 0.0 # start of the integration 
tStop = 10.0 # end of the integration 
h = 1.e-1
freq = 0
y0 = asarray( [ 0.0, 1.0, 2.0 ], dtype=float ) 

c = 8.2 # the first value of c 
T,Y = integrate(F,t0,y0,tStop,h) 
print "c= ", c 
printSoln(T,Y,freq)

# Plot the first solution: 
pylab.plot( T, Y[:,0], label='c=%5.3f'%c )
pylab.hold('on')

c = 8.3 # the second value of c 
T,Y = integrate(F,t0,y0,tStop,h) 
print "c= ", c 
printSoln(T,Y,freq)

# Plot the second solution: 
pylab.plot( T, Y[:,0], label='c=%5.3f'%c )

pylab.xlabel('t (time)'); pylab.title('u(t)') 
pylab.legend(loc='best')
pylab.grid('on')
pylab.axis('tight')
pylab.show() 

