#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi, exp
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t) ]
    F = zeros( (1,), dtype=float ) 
    F[0] = x - 10*y[0] 
    return F 

x0 = 0.0 # start of the integration 
xStop = 5.0 # end of the integration 
freq = 0

y0 = asarray( [ 10. ], dtype=float ) 

y_truth = lambda x: 0.1 * x - 0.01 + 10.01 * exp(-10*x) 
print "y_truth(%5.3f)= %5.3f" % (xStop,y_truth(xStop))

pylab.hold('on')

# Integrate this differential equation for using various step size (h) values:
for h in [ 0.1, 0.25, 0.5 ]: 
    X,Y = integrate(F,x0,y0,xStop,h) 
    print "h= ", h 
    printSoln(X,Y,freq)
    pylab.plot( X, Y[:,0], label='h= %5.2f' % h )

pylab.xlabel('x'); pylab.ylabel('y(x)')
pylab.grid('on')
pylab.legend(loc='best')
pylab.show() 
