#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from polyRoots import polyRoots 
if True:
    from run_kut4 import integrate
else:
    from run_kut5 import integrate
from printSoln import printSoln
import pylab 

m = 2.
c = 460.
k = 450.

print "What are the decay rates for this differential equation"
print polyRoots( [ k/m, c/m, 1. ] ) 

def F(x,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -(k/m) * y[0] - (c/m) * y[1] 
    return F 

x0 = 0.0 # start of the integration 
xStop = 0.2 # end of the integration 
freq = 0

y0 = asarray( [ 0.01, 0 ], dtype=float ) 

h = 0.001 # smaller than h_max 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,1] )
    pylab.xlabel('x'); pylab.ylabel("y'(x)")
    pylab.grid('on')
    pylab.show() 
