#!/usr/bin/env python
#
# Problem EPage 316
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t), y'(t), y''(t) ]
    F = zeros( (len(y),), dtype=float ) 
    F[0] = y[1]
    F[1] = y[2] 
    F[2] = -y[2] - 2*y[1] + 6
    return F 

x0 = 0.0 # start of the integration 
xStop = 1.0 # end of the integration 
h = 0.01
freq = 0

y0 = asarray( [ 2., 0., -8.659586 ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0], color='black', label='approx. sol.' )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.legend(loc='best')
    pylab.show() 
