#!/usr/bin/env python
#
# Problem EPage 360
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot

from stdForm import stdForm
from inversePower import inversePower

A = asarray( [ [ 1.4, 0.8, 0.4 ], [ 0.8, 6.6, 0.8 ], [ 0.4, 0.8, 5.0 ] ], dtype=float ) 
B = asarray( [ [ 0.4, -0.1, 0.0 ], [ -0.1, 0.4, -0.1 ], [ 0.0, -0.1, 0.4 ] ], dtype=float ) 

H, T = stdForm(A.copy(),B.copy())
print "H= "
print H 
print "T= "
print T 

# Estimate the smallest eigenvalue and eigenvector of the standard form problem:
# 
lam, z = inversePower(H,s=0)

# Transform this eigenvector back into the coordinates of the original problem: 
#
x = dot(T,z)
x /= sqrt(dot(x,x))

print lam, x

# Check everything is correct: 
assert np.linalg.norm( ( np.dot(A,x) - lam * dot(B,x) ).flatten() ) < 1.e-6











