#!/usr/bin/env python
#
# Problem EPage 360
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag

from stdForm import stdForm
from inversePower import inversePower

A = asarray( [ [ 4, -1, 0 ], [ -1, 4, -1 ], [ 0, -1, 4 ] ], dtype=float ) 
B = asarray( [ [ 2, -1, 0 ], [ -1, 2, -1 ], [ 0, -1, 1 ] ], dtype=float ) 

# Convert to standard form first (copy so that A and B are not destroyed in the stdForm routine):
# 
H, T = stdForm(A.copy(),B.copy())

# Estimate the eigenvalue and eigenvector of the standard form problem:
# 
s = 2.5
lam, z = inversePower(H,s)
print lam, z 

x = np.dot(T,z)
print x 

# Check for correctness of our results || AX - lambda BX || ~ 0 : 
assert np.linalg.norm( np.dot(A,x) - lam * np.dot(B,x) ) < 1.e-6









