#!/usr/bin/env python
#
# Problem EPage 360
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, dot, diag

from stdForm import stdForm
from jacobi import jacobi 
from sortJacobi import sortJacobi 

m = 0.25
k = 20
L = 0.75
g = 9.80665 

A = - asarray( [ [ -m*g - k*L, k*L ], [ k*L, -k*L - 2*m*g ] ], dtype=float )
B = diag( [m*L, 2*m*L] ).astype(float)

H,T = stdForm(A.copy(),B.copy()) # convert to standard form 
Lam, Z = jacobi(H.copy())        # solve via the Jacobi method
X = dot(T,Z)                     # the eigenvectors of the original problem
for jj in range(A.shape[1]):
    xMag = sqrt( dot(X[:,jj],X[:,jj]) )
    X[:,jj] /= xMag
sortJacobi(Lam,X)
print "eigenvalues= ", Lam
print "eigenvectors= "
print X 

# Check for correctness of our results || A X - lambda B X || ~ 0 : 
assert np.linalg.norm( ( dot(A,X) - np.tile( Lam, (B.shape[1],1) ) * dot(B,X) ).flatten() ) < 1.e-6
