#!/usr/bin/env python
#
# Problem EPage 387
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, diag, hstack
import pylab

from eigenvals3 import eigenvals3
from inversePower3 import inversePower3

ks = asarray( [ 400, 400, 400, 0.2, 400, 400, 200 ], dtype=float ) 

# Form the A matrix (only need the diagonal and off diagonal elements in an array):
# 
d = hstack( (ks[0:-1] + ks[1:],ks[-1]) )
c = -ks[1:] 

evalues = eigenvals3(d,c,4)
print "evalues= ", evalues

# Extract the eigenvectors corresponding to the lowest eigenvalues:
# 
lam_1, x_1 = inversePower3(d,c,evalues[0])
lam_2, x_2 = inversePower3(d,c,evalues[1])
lam_3, x_3 = inversePower3(d,c,evalues[2])
lam_4, x_4 = inversePower3(d,c,evalues[3])

if True: 
    indices = range(1,len(x_1)+1)
    pylab.plot( indices, x_1, label='lambda_1' )
    pylab.hold('on')
    pylab.plot( indices, x_2, label='lambda_2' )
    pylab.plot( indices, x_3, label='lambda_3' )
    pylab.plot( indices, x_4, label='lambda_4' )
    pylab.grid('on')
    pylab.xlabel('index')
    pylab.ylabel('relative magnitude')
    pylab.legend(loc='best')
    pylab.show()
