#!/usr/bin/env python
#
# Problem EPage 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import ones, sqrt, pi, diagonal 

from eigenvals3 import eigenvals3
from inversePower3 import inversePower3

compute_will_full_matrices = True

omega_1_truth = pi / 2 

for n in [ 10, 100, 500, 750, 1000 ]: 

    if not compute_will_full_matrices: 
        # Form the A initial matrix (the diagonal and subdiagonal parts):
        # 
        d = 2 * ones( (n,1), dtype=float ) 
        d[-1] = +1.0 

        c = -1 * ones( (n-1,1), dtype=float ) 

        # Adjust the A matrix by the multiplication on the right and left by B^{-1/2}:
        # 
        d[-1] *= 2.
        c[-1] *= sqrt(2)

        evalues = eigenvals3(d,c,1)
        lambda_1 = evalues[0]
        omega_1 = n * sqrt(lambda_1) 
        print "n= %4d: lambda_1= %10.6f; omega_1_approx= %10.6f; omega_1_truth= %10.6f" % (n,lambda_1,omega_1,omega_1_truth)
    else: 
        # For the FULL A matrix:
        # 
        A = 2. * np.identity( n, dtype=float ) 
        A[n-1,n-1] = +1.

        # fill the ith super diagonal: 
        i = +1 
        A.ravel()[i:max(0,A.shape[1]-i)*A.shape[1]:A.shape[1]+1] = -1 

        # fill the ith sub diagonal: 
        i = +1 
        A.ravel()[A.shape[1]*i:A.shape[1]*(i+A.shape[1]):A.shape[1]+1] = -1 

        # Adjust the A matrix by the multiplication on the right and left by B^{-1/2}:
        # 
        A[n-1,:] *= sqrt(2) 
        A[:,n-1] *= sqrt(2) 

        evalues, _ = np.linalg.eig(A)
        lambda_1 = sorted(evalues)[0]
        omega_1 = n * sqrt(lambda_1) 
        print "n= %4d: lambda_1= %10.6f; omega_1_approx= %10.6f; omega_1_truth= %10.6f" % (n,lambda_1,omega_1,omega_1_truth)


