#!/usr/bin/env python
#
# Problem EPage 389
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot, ones, identity

from stdForm import stdForm
from jacobi import jacobi 
from sortJacobi import sortJacobi 

n = 25

alpha = 1000. / (n+1)**4 

#
# Construct the matrix A:
# 

# The diagonal values:
# 
A = ( 6 + alpha ) * identity( n, dtype=float ) 
A[0,0] = 5 + alpha 
A[n-1,n-1] = 5 + alpha 

# fill the ith super diagonal: 
i = +1 
A.ravel()[i:max(0,A.shape[1]-i)*A.shape[1]:A.shape[1]+1] = -4

# fill the ith sub diagonal: 
i = +1 
A.ravel()[A.shape[1]*i:A.shape[1]*(i+A.shape[1]):A.shape[1]+1] = -4

# fill the ith super diagonal: 
i = +2
A.ravel()[i:max(0,A.shape[1]-i)*A.shape[1]:A.shape[1]+1] = +1

# fill the ith sub diagonal: 
i = +2 
A.ravel()[A.shape[1]*i:A.shape[1]*(i+A.shape[1]):A.shape[1]+1] = +1

#
# Construct the matrix B:
# 
B = 2 * identity( n, dtype=float ) 

# fill the ith super diagonal: 
i = +1 
B.ravel()[i:max(0,B.shape[1]-i)*B.shape[1]:B.shape[1]+1] = -1

# fill the ith sub diagonal: 
i = +1 
B.ravel()[B.shape[1]*i:B.shape[1]*(i+B.shape[1]):B.shape[1]+1] = -1

# Convert to standard form:
# 
H, T = stdForm(A.copy(),B.copy())
if False: 
    print "H= "
    print H 
    print "T= "
    print T 

Lam, Z = jacobi(H.copy())
X = dot(T,Z) # eigenvalues of the original problem 
for jj in range(A.shape[1]): # normalize eigenvectors 
    xMag = sqrt(dot(X[:,jj],X[:,jj]))
    X[:,jj] /= xMag
sortJacobi(Lam,X) # arrange in ascending order
print "n= %5d; three lowest matrix eigenvalues (lambda)= %s" % (n,Lam[:3])
if False: 
    print "eigenvectors= "
    print X

if False:
    print "Checking Ax = lambda B x for our solution"
    print "A x= "
    AX = dot(A,X)
    print AX 
    print "lambda B x= "
    LBX = np.tile( Lam, (B.shape[0],1) ) * dot(B,X)
    print LBX 
    print np.linalg.norm( ( AX - LBX ).flatten() )


