#!/usr/bin/env python
#
# Problem EPage 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, diagonal, identity, sqrt

from householder import householder, computeP
from eigenvals3 import eigenvals3
from inversePower3 import inversePower3

n = 50

# Form the A matrix:
# 
A = 2. * identity( n, dtype=float ) 

# fill the ith super diagonal: 
i = +1 
A.ravel()[i:max(0,A.shape[1]-i)*A.shape[1]:A.shape[1]+1] = -1 

# fill the ith sub diagonal: 
i = +1 
A.ravel()[A.shape[1]*i:A.shape[1]*(i+A.shape[1]):A.shape[1]+1] = -1 

# fill the value in the upper right corner:
A[0,n-1] = 1

A_orig = A.copy()

d, c = householder( A )
P = computeP(A)
if False: 
    print "diagonal d= "
    print d
    print "subdiagonal c= "
    print c
    print "transformation matrix P="
    print P

evalues = eigenvals3(d,c,5)
print "evalues= ", evalues

# Extract the eigenvector corresponding to the lowest eigenvalue:
# 
lam_1, v_1 = inversePower3(d,c,evalues[0])
x_1 = dot(P,v_1)
x_1 /= sqrt(dot(x_1,x_1)) 
if False: print "eigenvector of lowest eigenvalue= ", x_1 

# Check that we have found an eigenvector/eigenvalue of A x = lambda x:
# 
if False: 
    AX = dot(A_orig,x_1)
    LX = lam_1 * x_1 
    print np.linalg.norm( AX - LX )

print "eigenvalues computed with np.linalg.eig= "
evals, _ = np.linalg.eig(A_orig)
print map( lambda _: round(_,8), sorted(evals)[:5] )
